Subject: Linux-Development Digest #306
From: Digestifier <[email-masked]>
To: [email-masked]
Date: Fri, 14 Oct 94 09:13:08 EDT

Linux-Development Digest #306, Volume #2         Fri, 14 Oct 94 09:13:08 EDT

Contents:
  Motif / Linux - more link problems? (Douglas Frank)
  Re: Where to find latest changes.xx files? (Daniel Tran)
  Re: A badly missed feature in gcc (Dan Pop)
  Re: wxWindows 1.50k shared lib wanted (Jens Claussen)
  PS/2 and MCA support status? (Harri Pasanen)
  Will pcsndrv be included in 1.2? (Bryan Wright)
  strange lockups, bizarre networking... (Rob Newberry)
  RCS logs for kernels? (Marty Leisner 25733)
  Re: Linux 1.1.50+ cache scheme sucks (what happened to me?) (Marty Leisner 25733)
  my floppy stopped working with 1.1.52 (Marty Leisner 25733)
  Re: 1.1.52 bug? (Klaus Lichtenwalder)
  libc supports ssize_t and getline and other glibc extensions? ([email-masked])
  Re: PGP for Linux?? (Tim Bass (Network Systems Engineer))
  Good Video Card For Linux (Ron Blancarte)
  IPX in DOSEMU (Andrew Anderson)
  Contract Software development : Driver for PDMA16 I/O board (Jim Leven)
  Re: Compiling progs using port I/O ("Theodore Ts'o")

----------------------------------------------------------------------------

Crossposted-To: alt.uu.comp.os.linux.questions,comp.windows.x.motif
From: [email-masked] (Douglas Frank)
Subject: Motif / Linux - more link problems?
Date: Fri, 14 Oct 1994 01:41:43 GMT

This is part 2 of my ongoing struggle to get Motif installed on my
Linux box (Slackware 2.0).  Thanks to Torsten and one other (whose name I
rm'd too soon :) for your help; the below may _also_ be due to some missing
symlinks- but I don't know what other links SHOULD be present!

xmkmf produces a Makefile, part of which is extracted below.  Then,
'make Makefile' breaks when the imake command expands to '... -I./config....'

'make Makefile' completes if I link ./config to /var/X11/lib/X11/config,
but I doubt that's the real solution!  Can anyone point me to the reason that
NEWTOP isn't defined, or that IRULESRC isn't defined usefully?

        TOP = .
CURRENT_DIR = .
  CONFIGSRC = $(TOP)/config
   IRULESRC = $(CONFIGSRC)
      IMAKE = imake
  IMAKE_CMD = $(IMAKE) -DUseInstalled -I$(NEWTOP)$(IRULESRC) $(IMAKE_DEFINES)

Makefile::
        -@if [ -f Makefile ]; then set -x; \
        $(RM) Makefile.bak; $(MV) Makefile Makefile.bak; \
        else exit 0; fi
        $(IMAKE_CMD) -DTOPDIR=$(TOP) -DCURDIR=$(CURRENT_DIR)

The above produces:
c
% make Makefile
+ rm -f Makefile.bak
+ mv Makefile Makefile.bak
imake -DUseInstalled -I./config  -DTOPDIR=. -DCURDIR=.
:3: Imake.tmpl: No such file or directory
imake: Exit code 33.  Stop.
make: *** [Makefile] Error 1

Thanks!

--Doug

------------------------------

From: [email-masked] (Daniel Tran)
Subject: Re: Where to find latest changes.xx files?
Date: Thu, 13 Oct 1994 23:06:41 GMT

In article <[email-masked]> [email-masked] (Timothy Demarest) writes:
>sunsite and other mirrors dont seem to have the latest changes files
>for the newer kernels.  Where can I find some info on what changes are
>taking place?

>--
>Timothy Demarest   | Radiation Effects Research Foundation| WWW: http://
>[email-masked]| Research Information Center          | aqua.rerf.or.jp/
>CIS: 100212,562    | 5-2 Hijiyama Park, Minami-ku         | .Inside/demarest/
>                   | Hiroshima 732 Japan                  | NewChiba.html

Try ftp.msen.com

Daniel Tran

------------------------------

From: [email-masked] (Dan Pop)
Subject: Re: A badly missed feature in gcc
Date: Thu, 13 Oct 1994 23:10:57 GMT

In <wcreator.782071420@kaiwan009> [email-masked] (Steven M. Doyle) writes:

>In Borland's Pascal compilers for (ack) dos, both the (*-*) and {-}
>style comments are supported.  I don't find this horribly unusual.

The two styles of Pascal comments are essentially one and the same.
When Pascal was designed (about 25 years ago) many terminals (and card
punches :-) didn't support curly braces, so (* was used instead of {
and *) instead of }. The same problem had to be solved for [ and ]
which were replaced by (. and .)

Dan
--
Dan Pop 
CERN, CN Division
Email: [email-masked]
Mail:  CERN - PPE, Bat. 31 R-004, CH-1211 Geneve 23, Switzerland

------------------------------

From: [email-masked] (Jens Claussen)
Subject: Re: wxWindows 1.50k shared lib wanted
Date: 14 Oct 1994 08:41:20 GMT

In article <[email-masked]>,
Tall Sword <[email-masked]> wrote:
>I have compiled wxWindows 1.50k in my Linux box and found it quite useful
>for developing cross platform GUI program. But the wxWindows 1.50k only
>generate a static lib for me and it make the executable file quite large 
>and the time of compiling is longer too.
>
>Anyone else where got a copy of shared lib of wxWindows 1.50k? I realized
>that there is copy in sunsite that support shared lib but that version is 
>older that only support XView 3.1. Please direct me to the right site and
>directories to get the shared lib. 
>
You can find a shell archive containing a script and instructions on
how to build a wxwin shared library in 

skye.aiai.ed.ac.uk:/pub/wxwin/contrib/linux_shared_lib.shar

(This is the home site for wxwin, anyway.)

Jens

-- 
Jens Claussen   ____    Universitaet Passau, Germany
               (____)   email: [email-masked]
               | db |   WWW  : http://dodgers.fmi.uni-passau.de/~claussen
               `----'           

------------------------------

From: [email-masked] (Harri Pasanen)
Subject: PS/2 and MCA support status?
Date: 12 Oct 1994 08:17:40 GMT

There have been some posts recently that state that MCA support has
improved in recent kernels.

Some drivers seem to have MCA specific code in them, but config.in
says nothing about MCA.

I'd like to know the current status of this.

Thanks,

Harri
--
======================================================
Harri Pasanen           [email-masked]

------------------------------

From: [email-masked] (Bryan Wright)
Subject: Will pcsndrv be included in 1.2?
Date: Tue, 11 Oct 1994 16:37:06 GMT

Hi Folks,

        Just a quick question:  Does anyone know if pcsndrv will be included
in kernel version 1.2 when it comes out?

                                Thanks in advance,
                                Bryan

--
===============================================================================
Bryan Wright                |"If you take cranberries and stew them like 
Physics Department          | applesauce, they taste much more like prunes 
University of Virginia      | than rhubarb does."  --  Groucho 
Charlottesville, VA  22901  |                   
(804) 924-6814              |         [email-masked]
===============================================================================

------------------------------

From: [email-masked] (Rob Newberry)
Crossposted-To: comp.os.linux.admin,comp.os.linux.help
Subject: strange lockups, bizarre networking...
Date: Mon, 10 Oct 1994 00:40:14

As was posted several days ago, my machine is one of those which has been 
having strange lockups the past weeks.  Basically, when I upgraded from 1.1.10 
to 1.1.45 (and now 1.1.50), my system will occasionally hang hard.  A 
power-reset is the only thing to bring it back.

Another person sent me a possible fix, claiming that it may be a portion of 
the ne.c code (the system does use an NE2000 clone). However, that patch did 
not stop the lockups from occuring.  I suppose I may need to invest in another 
network card...

Before doing that, though, I thought it might be beneficial to the Linux 
developers if I told them some more about the symptoms we've been having 
lately.

Usually, there are 4-5 machines active on the network.  3-4 WfWg machines, and 
1-2 Macs.  The Linux machine is a Dell 486, 720 MB IDE drive (w/ 30MB SWAP), 8 
MB RAM, and an NE2000 card.  The Linux machine is also connected to a 28.8 K 
modem, and runs DIP to connect our LAN to the internet.  It is connected to an 
additional modem and runs FlexFax.  Finally, the machine also runs SAMBA to 
serve files/printers to the WfWg machines.  I am currently working on making 
CAP work, and at times it is running some CAP processes -- but usually not for 
very long.  And in any event, running CAP is not consistent with the times the 
machine hangs.

Finally, one more bit of information.  Often times the hangs are preceded by 
periods of sluggish network performance.  My telnet logins to the machine will 
simply sit there as I type commands, then eventually they'll work.

Also, tonight something VERY strange happened.  My Linux machine stopped 
responding to my LAN, so I ran "arp -a".  Only two machines were listed, but 
both had a hardware address of 00:00:00:00:00:00.

It looked like this:

Address                 HW type               HW address              Flags 
(ip of machine 1)   10Mbps Ethernet   00:00:00:00:00:00       C
(ip of linux box)     10Mbps Ethernet   00:00:00:00:00:00

Running it now, arp still reports 00:00:00:00:00:00 for the linux machine 
(itself that is) -- I don't know if that is correct or not.  It does, however, 
have the correct address for the other machine now, and it has it's own 
correct address when I run "ifconfig".

Anyway, these are the facts.  If any of the developers can figure out how to 
get around these hangs, I (and several others I know) would be greatly 
appreciative.  I hope that this information will help, and if I can be of any 
more assistance, please let me know.

Thanks!

Rob Newberry

*******************************************************************
Rob Newberry               Education and Technology Solutions, Inc.
Email: [email-masked]        4303 Parkland Court
Phone: 301 438 3915        Rockville, Maryland 20853
FAX: 301 438 3748

      The secret to happiness is knowing how many
          weekdays you can afford a hangover.

*******************************************************************

------------------------------

From: leisner@batman (Marty Leisner 25733)
Subject: RCS logs for kernels?
Reply-To: [email-masked]
Date: Thu, 13 Oct 1994 16:40:48 GMT

Has anyone done an RCS system for the kernel?

I moved from 1.1.19 to 1.1.52 and I see:
        1) a lot of improvements
        2) some broken things

Where can I find rcs logs to find out what changed in which
releases?

If it isn't present, it doesn't seem to hard to make
it...

--
marty
[email-masked]  
Member of the League for Programming Freedom
Object techonology is to software what microprocessors are to
hardware.
                Phillipe Kahn

------------------------------

From: leisner@batman (Marty Leisner 25733)
Subject: Re: Linux 1.1.50+ cache scheme sucks (what happened to me?)
Reply-To: [email-masked]
Date: Thu, 13 Oct 1994 16:42:11 GMT

I assume buffers is the disk cache...

How can this be tuned?

--
marty
[email-masked]  
Member of the League for Programming Freedom
We don't actually do anything new in computing, we just rename the old stuff.
                                Grace Murray Hopper, who OOed in 1944

------------------------------

From: leisner@batman (Marty Leisner 25733)
Subject: my floppy stopped working with 1.1.52
Reply-To: [email-masked]
Date: Thu, 13 Oct 1994 16:47:08 GMT

I was running 1.1.19.

I just upgraded to 1.1.52.

Everything works (and the problem with find /cdrom  does recursive descends
for non-rock-ridge) but /dev/fd0 isn't working

(/dev/fd0 is a 3 1/2" disk, /dev/fd1 is a 5 1/4" disk, I have a 
Compaq Presario 850.

I tried to read /dev/fd1 (od -c /dev/fd1) and have no problem...

But when I try to read /dev/fd0 I get an open error (it doesn't seem to be there...)

When I boot up I get:
Oct 12 07:45:43 compaq kernel: Floppy drive(s): fd0 is 1.44M, fd1 is 1.2M
Oct 12 07:45:43 compaq kernel: FDC 0 is a post-1991 82077

When I tried the floppy in /var/adm/message I got:
But I tried to read/write a floppy disk and I get:
Oct 12 07:47:09 compaq kernel: VFS: Disk change detected on device 2/0
Oct 12 07:47:09 compaq kernel: floppy I/O error
Oct 12 07:47:09 compaq kernel: dev 0200, sector 0
Oct 12 07:47:32 compaq kernel: VFS: Disk change detected on device 2/0
Oct 12 07:47:32 compaq kernel: floppy I/O error
Oct 12 07:47:32 compaq kernel: dev 0200, sector 0
Oct 12 07:47:51 compaq kernel: VFS: Disk change detected on device 2/28
Oct 12 07:50:35 compaq kernel: VFS: Disk change detected on device 2/0
Oct 12 07:50:35 compaq kernel: floppy I/O error
Oct 12 07:50:35 compaq kernel: dev 0200, sector 0

There were substantial changes to the floppy driver.

I tried the 1.1.19 floppy driver and got all type of compiler errors (seems the
structures changed).

What's going on....

--
marty
[email-masked]  
Member of the League for Programming Freedom
We don't actually do anything new in computing, we just rename the old stuff.
                                Grace Murray Hopper, who OOed in 1944

------------------------------

From: [email-masked] (Klaus Lichtenwalder)
Subject: Re: 1.1.52 bug?
Date: Wed, 12 Oct 1994 08:36:33 GMT

[email-masked] (Rasmus Lerdorf) writes:

>[email-masked] (Riku Saikkonen) writes:
>>I can't be really sure if this is a kernel bug, because I just did a
>>quite heavy upgrade of the machine (switched to a VLB motherboard +
>>display adapter + IDE host adapter). That's why I'm asking...
>>Hmm, now I compiled 1.1.50, and it seems to work. Except for one crash
>>in X, but that is probably something else (no kernel panic or anything
>>in the log). So I think it is a bug in 1.1.52...

>I have been running 1.1.52 for close to a week now.  Not a single
>crash yet.  VLB motherboard, 486dx2-66, Adaptec 1542 SCSI controller,
>VLB Cirrus 5428 video and 16 Mb of Ram.

Same with me. ISA motherbord, 486sx25, IDE controller, 20megs RAM,
4 Serial (3 14.4modems, one mouse), 1 parallel printer, et400 card (X)
ne2000 compatible

Klaus
-- 
__________________________________________________________________________
Klaus Lichtenwalder, Dipl. Inf., Buschingstr. 65
D-81677 Muenchen, F.R. Germany,  Fax +49-89-98292755
email: [email-masked], [email-masked]

------------------------------

From: [email-masked]
Subject: libc supports ssize_t and getline and other glibc extensions?
Date: 10 Oct 1994 04:56:26 GMT

After reading Michael K. Johnson's article in Linux Joural vol.1                
I believe, I had it in my mind to try out the GNU libc extensions.              
But they don't seem to work.  Here is a short test program:                     
#include <stdio.h>                                                              
 
main()                                                                          
{                                                                               
ssize_t **LINEPTR;                                                              
char *N = "text";                                                               
 
  while(getline(LINEPTR, N, stdin) != -1)                                       
    printf("%s", *LINEPTR);                                                     
  return 0;                                                                     
}                                                                               
OK, so maybe I don't understand the glibc info documentation, but               
ssize_t is rejected by the compiler and when I make it into                     
size_t, getline is rejected by the linker.  "cd /usr/lib; nm lib* |             
grep _getline" shows that it's not included in any of my                        
Slackware 1.2.1 libs and I just replaced them with 2.0.1 and                    
still no go.  Are these GNU extensions not implemented in the                   
Linux libc?  Or am I demonstrating my C ignorance :)                            
Perhaps a simple gcc flag turns this on??                                       
--                                                                              
Christopher J. Fearnley       |   UNIX SIG Leader at PACS                       
[email-masked]        |   (Philadelphia Area Computer Society)          
[email-masked]          |   Design Science Revolutionary                  
[email-masked]  |   Explorer in Universe                          
503 S 44th ST                 |   Linux Advocate                                
Philadelphia PA 1914-3907     |   (215)349-9681                                 

------------------------------

From: [email-masked] (Tim Bass (Network Systems Engineer))
Subject: Re: PGP for Linux??
Date: 11 Oct 1994 01:39:36 GMT

Absolutely, just say make.

[email-masked] wrote:
: Zack T. Smith ([email-masked]) wrote:

: : Can anyone tell me whether PGP (the encyption utility) been ported Linux?
: : I haven't been able to find it in the archives...

: "since about forever" PGP compiles out-of-the-box under Linux.
: grab a copy of the source code and type 'make'.

------------------------------

From: [email-masked] (Ron Blancarte)
Subject: Good Video Card For Linux
Date: 10 Oct 1994 04:41:01 GMT

My Brother-in-Law is getting a PC to run Linux on one partition, and
Windows/Dos on the other one.  Now anyone can make Win/Dos Drivers, but we are
looking for a Video card that has really good Linux drivers.  Things to take
note when giving advice:  We are not looking for a 64 bit Video card, so
please don't recomend them, unless they are the best card hands down.

Please e-mail responces back to me.  I  don't frequent this group.

RonB

------------------------------

From: [email-masked] (Andrew Anderson)
Subject: IPX in DOSEMU
Date: 14 Oct 1994 01:42:15 GMT

I've been poking around in the source for DOSEMU and I have seen references
to a "/etc/dosemu/dos.ini" but I haven't been able to find any 
documentation on this initialization file.  Can anyone shed some light
on this for me?

Also, is the ipx built into DOSEMU designed to replace the ipx.com/
ipxodi.com drivers?  I have been trying to get the internal drivers to
allow me to use netx without any other drivers, but with no success.

While on this, the other day I was experimenting with VLMs under DOS. 
I found that if you load ipxodi, then start windows without loading
VLM, you can then open multiple DOS boxes under windows and have
multiple *independant* connections to the NetWare file server
going concurrently.  So I was wondering..._if_ the IPX built into
DOSEMU can supply ipx.com or ipxodi.com functionality, then it should
be possible to load either netx or vlm from each DOSEMU session,
and connect multiple times to the server without getting a security
lockout.

The implementation might look something like this:

|=================|   |====================|   |==================|
|   DOSEMU #1     |   |   DOSEMU   #2      |   |   DOSEMU  #3     |
|=================|   |====================|   |==================|
        |                       |                        |
        --------------------------------------------------
                                |
                       |==================|
                       |  IPX Stack       |--------- Network
                       |==================|
                          
If the IPX part of the kernel had the proper hooks in it, it could
establish a connection when the first DOSEMU started, then each
following DOSEMU session would request another IPX node assignment,
similar to what I was doing the other day under windows.

I know that this topic has alot of interest, but I don't think I've
seen this approach mentioned before...If it has, well, I've just
re-invented the wheel! :)

--
|===========================================================================|
|  Andrew Anderson                              [email-masked]          |
|  Novell Network System Administrator          "Making the impossible      |
|  Linux System Administrator                    possible -- daily!"        |
|                                                                           |
| I don't speak for ERAU, and God knows I don't want them to speak for me!  | 
|===========================================================================|

------------------------------

From: [email-masked] (Jim Leven)
Subject: Contract Software development : Driver for PDMA16 I/O board
Date: 11 Oct 1994 01:45:19 GMT

I wish to contract the development of a Linux driver for the PDMA16 
digital I/O board.
     
The PDMA16 is a 16 bit DMA interface board capable of transfer rates 
up to 250 kbytes/s in blocks of 64 kbytes.  I wish to interface this 
to an eavesdropping data acquisition system to read 3.2 Mbyte records 
at a rate of 175 kbytes/s.
     
A DOS driver for this card coded in C is available as a basis for porting 
to Linux, and a PDMA16 card and information is also available for testing.
     
Experience with Linux and device drivers is essential.
     
If you are interested, please contact me.  I can provide the source code 
for the DOS driver and some further information on the PDMA16.  

I require :
1) an outline of your experience with Linux and writing device drivers
2) your initial estimate of the contract price for the development 
3) an estimation of the time you would require for the development.
     
Jim Leven
Australian Geological Survey
[email-masked]
Phone Australia 6 249 9275
Fax   Australia 6 249 9972

------------------------------

From: "Theodore Ts'o" <[email-masked]>
Subject: Re: Compiling progs using port I/O
Date: 14 Oct 1994 09:02:41 -0400
Reply-To: [email-masked]

   From: [email-masked] (Frank Lofaro)
   Date: Fri, 7 Oct 94 03:07:40 GMT

   >> >I'm trying to compile a program that uses the inb and outb
   >> >functions (macros, actually) but when it comes to link time
   >> >all my inb/outb calls are represented as unresolved references
   >> >to ___outb (or ___outcb) and ___inb...
   >

   Yes, there is.
   extern inline is used instead of static inline in the function definitions. 
   This is a Bad Thing. Without optimization, inline is ignored, thus 
   extern inline becomes extern, which means it is not defined. Using static 
   inline would mutate to static when not optimizing, which would still work 
   (it would not be inline of course, but it wouldn't fail to compile, either).

The problem with using static inline is that you get copies of the
function included with every single .o file which had included 
#include <asm/io.h>.  

There is a better solution, which requires support from a library
(probably libc in this case, or perhaps we would create a new library
for this purpose).

The trick is that in the .h file, you do something like this....

=============================================================
/* declaration of inline functions */
extern void ext2fs_mark_super_dirty(ext2_filsys fs);

/*
 * The actual inlined functions definitions themselves...
 *
 * If NO_INLINE_FUNCS is defined, then we won't try to do inline
 * functions at all!
 */
#if (defined(INCLUDE_INLINE_FUNCS) || !defined(NO_INLINE_FUNCS))
#ifdef INCLUDE_INLINE_FUNCS
#define _INLINE_ extern
#else
#define _INLINE_ extern __inline__
#endif

/*
 * Mark a filesystem superblock as dirty
 */
_INLINE_ void ext2fs_mark_super_dirty(ext2_filsys fs)
{
        fs->flags |= EXT2_FLAG_DIRTY | EXT2_FLAG_CHANGED;
}

...

#endif

=============================================================

.... and then in the a inline.c which is included in the library, you
have something like this:

#define INCLUDE_INLINE_FUNCS

#include "ext2fs.h"

=============================================================

This way, if a program is compiled -O, it will use the inline functions
found in the .h file.  However, if a program is compiled -g, then it
won't use the inline functions, so when it links with the library, it
will pull in inline.o, which contains a single copy of the inline
functions.  This way you don't get multiple copies of the inline
functions included into your program.  And, if all of your modules are
compiled -O, inline.o won't get pulled in from the library at all.

                                                - Ted

------------------------------

** FOR YOUR REFERENCE **

The service address, to which questions about the list itself and requests
to be added to or deleted from it should be directed, is:

    Internet: [email-masked]

You can send mail to the entire list (and comp.os.linux.development) via:

    Internet: [email-masked]

Linux may be obtained via one of these FTP sites:
    nic.funet.fi				pub/OS/Linux
    tsx-11.mit.edu				pub/linux
    sunsite.unc.edu				pub/Linux

End of Linux-Development Digest
******************************